#!/usr/bin/perl

#    households.pl - Households utility
#    Copyright (C) 2000 Michael Jung
#    e-mail: miju@phantasia.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use CGI;
use CGI::Carp qw(fatalsToBrowser);
$| = 1;

$FILE_LOCATION = "../cgi-tmpl/households/";

#########
### INPUT
#########

$q = new CGI;

foreach (1..3000) {
    ${"A$_"} = $q->param("\$A$_") if ($q->param("\$A$_") ne "");
}

#########
### CONSTANTS
#########

sub FDI {
    return $_[0] if ($_[0] < 32);
    my @t = 
        ( 33, 36, 40, 45, 51, 57, 64, 72, 81, 92,
          104, 117, 131, 146, 162, 179, 197, 216, 236, 100000 );
    my $i = 0;
    $i++ while ($t[$i] <= $_[0]);
    return $i + 31;
}

sub CLI {
    return $_[0]*4 if ($_[0] < 2.5);
    my @t = ( 2.75, 3.5, 4.5, 5.75, 7.25, 9, 11, 13.25, 15.75, 18.5,
              21.5, 24.75, 28.25, 32, 36, 100000 );
    my $i = 0;
    $i++ while ($t[$i] <= $_[0]);
    return $i + 9;
}

sub LXI {
    my @t = ( 0, 3, 7, 12, 18, 25, 33, 42, 52, 63,
              75, 88, 102, 117, 133 );
    my $i = 0;
    $i++ while ($t[$i] <= $_[0]);
    return $i - 1;
}

#########
### CALCULATIONS
#########

# Name
$A301 ="Default" if (precond("!A301"));

# Location
$A300 ="Harn" if (precond("!A300"));

# MRF
$A302 ="1.0" if (precond("!A302"));

# Location
$A303 ="1/720" if (precond("!A303"));

$Nf = $Nr = 0;
foreach my $j (10..29) {
    if (${"A".($j*100 + 1)} ne "") {
        (${"A".($j*100 + 3)} ne "") ? $Nr++ : $Nf++;
    }
}

if ($Nf + $Nr == 0) {
    # Name
    $A1001 = "Default";
    # Position
    $A1002 = "Head" if (precond("!A2002"));
    $Nf = 1;
}

my @tmp;

# Residents (musts)
foreach my $j (10..29) {
    my $k = 100*$j;
    # Name
    ${"A".($k + 1)} = "" if (precond("!A".($k + 1)));
    # Position
    ${"A".($k + 2)} = "" if (precond("!A".($k + 2)));
    # Wage
    ${"A".($k + 3)} = "" if (precond("!A".($k + 3)));
    if (${"A".($k + 1)} ne "") {
        foreach my $i (5,8,11) {
            # PEFs
            ${"A".($k + $i)} = "0.1"
                if (precond("!A".($k + $i)));
            # EFHs
            if (precond("!A".($k + $i + 1)." && A".($k + $i - 1))) {
                ${"A".($k + $i + 1)} = ${"A".($k + $i)} * ${"A".($k + $i - 1)};
            }
            # Hours
            if (precond("!A".($k + $i - 1)." && A".($k + $i + 1))) {
                ${"A".($k + $i - 1)} =
                    int(${"A".($k + $i + 1)}*100/${"A".($k + $i)})/100;
            }
        }
    }
    # Hours
    ${"A".($k + 13)} = ${"A".($k + 4)} + ${"A".($k + 7)} + ${"A".($k + 10)}
    if (precond("A".($k + 4)." && A".($k + 7)." && A".($k + 11)));

    $tmp[0] += ${"A".($k + 6)};
    $tmp[1] += ${"A".($k + 9)};
    $tmp[2] += ${"A".($k + 12)};
    $tmp[3] += ${"A".($k + 3)};
}

# Total EFHs
$A304 = $efh[0] if (precond("!A304"));
$A307 = $efh[1] if (precond("!A307"));
$A310 = $efh[2] if (precond("!A310"));

# TSF
$A432 ="10" if (precond("!A432"));

# LDFs
$A305 = 90 + 4*($Nf + $Nr);
$A308 = 3*$Nf + 2*$Nr;
$A311 = int($A432*5)/100 + $Nf + $Nr;

# LFs
$A306 = int($A304/$A305*100)/100 if (precond("!A306"));
$A409 = $A306;
$A309 = int($A307/$A308*100)/100 if (precond("!A309"));
$A410 = $A309;
$A312 = int($A310/$A311*100)/100 if (precond("!A312"));
$A411 = $A312;

# Budget
$A401 = 0 if (precond("!A401"));
$A402 = 0 if (precond("!A402"));
$A403 = 0 if (precond("!A403"));
$A404 = 0 if (precond("!A404"));
$A405 = $tmp[3] if (precond("!A405"));
$A406 = 0 if (precond("!A406"));
$A407 = 0 if (precond("!A407"));

# Total
$A408 = $A401 + $A402 + $A403 + $A404 + $A405 + $A406 + $A407
    if (precond("!A408"));

# MRFs
$A412 = $A302 if (precond("!A412"));
$A413 = $A302 if (precond("!A413"));
$A414 = $A302 if (precond("!A414"));
$A415 = $A302 if (precond("!A415"));

# Num/R
$A416 = $Nr + $Nf if (precond("!A416"));
$A417 = $Nr + $Nf if (precond("!A417"));
$A418 = $Nr + $Nf if (precond("!A418"));
$A419 = $Nr + $Nf if (precond("!A419"));
$A421 = $Nr + $Nf if (precond("!A421"));

# Val/R
$A422 = int($A401*$A409*$A412/$A416*100)/100 if (precond("!A422"));
$A423 = int($A402*$A410*$A413/$A417*100)/100 if (precond("!A423"));
$A424 = int($A403*$A411*$A414/$A418*100)/100 if (precond("!A424"));
$A425 = int($A404*$A415/$A419*100)/100 if (precond("!A425"));
$A426 = int($A432/$A421*100)/100 if (precond("!A426"));

# Indices
$A427 = &FDI($A422) if (precond("!A427"));
$A428 = &CLI($A423) if (precond("!A428"));
$A429 = &FDI($A424) if (precond("!A429"));
$A430 = &LXI($A425) if (precond("!A430"));
$A431 = min(20, int($A432*5/$A421)/100) if (precond("!A431"));

$A433 = $A427 + $A428 + $A429 + $A430 + $A431
    if (precond("!A433"));

$A430 = min(.1 * $A433, $A430);

sub precond { $_ = shift; s/([A-Za-z0-9]+)/"defined(\$$1)"/eg; return eval; }

sub min { return ($_[0] < $_[1]) ? $_[0] : $_[1]; }

#########
### OUTPUT
#########

$gs = "| gs -q -dNOPAUSE -dBATCH -sDEVICE=\$d -sOutputFile=- -c save pop -";

# PREPARE (STD)OUT

%action = ("HTML" => [".html","text/html"],
	   "PS" => [".ps","application/postscript"],
	   "FIG" => [".fig","application/fig"],
	   "JPEG" => [".ps","image/jpeg"],
	   "PDF" => [".ps","application/pdf"],
	   "FORM" => ["f.html","text/html"]);

open(FILE, "<".$FILE_LOCATION."households".$action{$q->param("action")}[0]) ||
    die "Can't open file: $!";
print $q->header(-type => $action{$q->param("action")}[1],
		 -attachment => "households".$action{$q->param("action")}[0]);

if ($q->param("action") eq "HTML") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "PS") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "FIG") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print $i;
    }
}
if ($q->param("action") eq "JPEG") {
    $d = "jpeggray -r141"; $gs =~ s/\$d/$d/;
    open PDF, $gs;
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print PDF $i;
    }
    close(PDF);
}
if ($q->param("action") eq "PDF") {
    $d = "pdfwrite"; $gs =~ s/\$d/$d/;
    open PDF, $gs;
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)/$ {"$1"}/;
	print PDF $i;
    }
    close(PDF);
}
if ($q->param("action") eq "FORM") {
    while (my $i = <FILE>) {
	$i =~ s/\$([A-B][0-9]+[a-e]?)\" value=\"/\$$1\" value=\"$ {"$1"}/;
	print $i;
    }
}
close(FILE);
